Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QAtomicElectronScattering.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QAtomicElectronScattering.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QAtomicElectronScattering.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4QAtomicElectronScattering.cc,v 1.4 2008/10/02 21:10:07 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QAtomicElectronScattering.cc,v 1.5 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QAtomicElectronScattering class -----------------
@@ -34,5 +34,16 @@
 // ********** This CLASS is temporary moved from the photolepton_hadron directory *********
 // ****************************************************************************************
-
+// Short description: CHIPS is re3sponsible for photo- and lepto-nuclear
+// reactions. In particular for thr electron-nuclear reactions. At High
+// Energies the nucleons (including neutrons) and nuclear fragments can
+// interact with atomic electrons (reversed electro-nuclear reaction -
+// antilab), while they are missing the nucler-nuclear (ion-ion) reac-
+// tions. This nucleo-electron process comes "for-free" in CHIPS, as the
+// cross-sections of the interaction is known from the electro-nuclear
+// reactions. The only problem is to move the output from the antilab to
+// lab system. This is what this process is aiming to do. It can be used
+// for the ion transport in Geant4.
+// ---------------------------------------------------------------------
+   
 //#define debug
 //#define pdebug
@@ -74,8 +85,10 @@
 
 // Fill the private parameters
-void G4QAtomicElectronScattering::SetParameters(G4double temper, G4double ssin2g, G4double etaetap,
-                                     G4double fN, G4double fD, G4double cP, G4double mR,
-                                     G4int nParCW, G4double solAn, G4bool efFlag,
-                                     G4double piThresh, G4double mpisq, G4double dinum)
+void G4QAtomicElectronScattering::SetParameters(G4double temper, G4double ssin2g,
+                                                G4double etaetap, G4double fN, G4double fD,
+                                                G4double cP, G4double mR, G4int nParCW,
+                                                G4double solAn, G4bool efFlag,
+                                                G4double piThresh, G4double mpisq,
+                                                G4double dinum)
 {//  =============================================================================
   Temperature=temper;
@@ -263,5 +276,5 @@
 #ifdef debug
   G4int prPDG=particle->GetPDGEncoding();
-		G4cout<<"G4QAtomElScat::PostStepRestDoIt: projPDG="<<projPDG<<",stPDG="<<prPDG<<G4endl;
+  G4cout<<"G4QAtomElScat::PostStepRestDoIt: projPDG="<<projPDG<<",stPDG="<<prPDG<<G4endl;
 #endif
   if(!projPDG)
@@ -274,5 +287,5 @@
   for(i=0; i<nE; ++i)
   {
-	   G4double frac=material->GetFractionVector()[i];
+    G4double frac=material->GetFractionVector()[i];
     sum+=frac;
     sumfra.push_back(sum);             // remember the summation steps
@@ -299,5 +312,5 @@
     G4int curInd=G4QIsotope::Get()->GetLastIndex(Z);
     if(!curInd)                       // The new artificial element must be defined 
-				{
+    {
       std::vector<std::pair<G4int,G4double>*>* newAbund =
                                                new std::vector<std::pair<G4int,G4double>*>;
@@ -307,12 +320,12 @@
         N=pElement->GetIsotope(j)->GetN()-Z;
         if(pElement->GetIsotope(j)->GetZ()!=Z) G4cerr<<"*G4QCaptureAtRest::AtRestDoIt: Z="
-																																							 <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
+                                        <<pElement->GetIsotope(j)->GetZ()<<"#"<<Z<<G4endl;
         G4double abund=abuVector[j];
-								std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
+        std::pair<G4int,G4double>* pr= new std::pair<G4int,G4double>(N,abund);
 #ifdef debug
         G4cout<<"G4QAtomElScat::PostStepDoIt:pair#="<<j<<", N="<<N<<",ab="<<abund<<G4endl;
 #endif
         newAbund->push_back(pr);
-						}
+      }
 #ifdef debug
       G4cout<<"G4QAtomElectScat::PostStepDoIt:pairVectorLength="<<newAbund->size()<<G4endl;
@@ -333,5 +346,5 @@
   if(dsr<dd)dsr=dd;
   if(manualFlag) G4QNucleus::SetParameters(freeNuc,freeDib,clustProb,mediRatio); // ManualP
-		else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
+  else if(projPDG==-2212) G4QNucleus::SetParameters(1.-dsr-dsr,dd+dd,5.,10.);//aP ClustPars
   else if(projPDG==-211)  G4QNucleus::SetParameters(.67-dsr,.32-dsr,5.,9.);//Pi- ClustPars
 #ifdef debug
@@ -343,6 +356,6 @@
     return 0;
   }
-		if(projPDG==11||projPDG==-11||projPDG==13||projPDG==-13||projPDG==15||projPDG==-15)
-		{ // Lepto-nuclear case with the equivalent photon algorithm. @@InFuture + neutrino & QE
+  if(projPDG==11||projPDG==-11||projPDG==13||projPDG==-13||projPDG==15||projPDG==-15)
+  { // Lepto-nuclear case with the equivalent photon algorithm. @@InFuture + neutrino & QE
     G4double kinEnergy= projHadron->GetKineticEnergy();
     G4ParticleMomentum dir = projHadron->GetMomentumDirection();
@@ -443,32 +456,32 @@
   G4cout<<"G4QAtomElScat::PostStepDoIt: projPDG="<<projPDG<<", targPDG="<<targPDG<<G4endl;
 #endif
-  G4QHadron* pH = new G4QHadron(projPDG,proj4M);                // ---> DELETED -->--   -+
+  G4QHadron* pH = new G4QHadron(projPDG,proj4M);                // ---> DELETED -->------*
   if(momentum<1000.) // Condition for using G4QEnvironment (not G4QuasmonString)         |
-		{ //                                                                                   |
+  { //                                                                                   |
     G4QHadronVector projHV;                                 //                           |
-    projHV.push_back(pH);                                   // DESTROYED over 2 lines -+ |
-    G4QEnvironment* pan= new G4QEnvironment(projHV,targPDG);// ---> DELETED --->-----+ | |
-    std::for_each(projHV.begin(), projHV.end(), DeleteQHadron()); // <---<------<----+-+-+
-    projHV.clear(); // <------------<---------------<-------------------<------------+-+ .
+    projHV.push_back(pH);                                   // DESTROYED over 2 lines -* |
+    G4QEnvironment* pan= new G4QEnvironment(projHV,targPDG);// ---> DELETED --->-----* | |
+    std::for_each(projHV.begin(), projHV.end(), DeleteQHadron()); // <---<------<----+-+-*
+    projHV.clear(); // <------------<---------------<-------------------<------------+-* .
 #ifdef debug
     G4cout<<"G4QAtomElectScat::PostStepDoIt: pPDG="<<projPDG<<", mp="<<mp<<G4endl;// |   .
 #endif
-    try                                                           //                 |   .
-	   {                                                             //                 |   .
-	     delete output;                                              //                 |   .
+    try                                                           //                 |   ^
+    {                                                             //                 |   .
+      delete output;                                              //                 |   ^
       output = pan->Fragment();// DESTROYED in the end of the LOOP work space        |   .
-    }                                                             //                 |   .
+    }                                                             //                 |   ^
     catch (G4QException& error)//                                                    |   .
-	   {                                                             //                 |   .
-	     //#ifdef pdebug
+    {                                                             //                 |   ^
+      //#ifdef pdebug
       G4cerr<<"**G4QAtomElectScat::PostStepDoIt:G4QE Exception is catched"<<G4endl;//|   .
-	     //#endif
+      //#endif
       G4Exception("G4QAtomElScat::PostStepDoIt:","27",FatalException,"CHIPScrash");//|   .
-    }                                                             //                 |   .
-    delete pan;                              // Delete the Nuclear Environment <--<--+   .
-  } //                                                                                   .
+    }                                                             //                 |   ^
+    delete pan;                              // Delete the Nuclear Environment <--<--*   .
+  } //                                                                                   ^
   else               // Use G4QuasmonString                                              .
-		{ //                                                                                   ^
-    G4QuasmonString* pan= new G4QuasmonString(pH,false,targPDG,false);//-> DELETED --+   |
+  { //                                                                                   ^
+    G4QuasmonString* pan= new G4QuasmonString(pH,false,targPDG,false);//-> DELETED --*   .
     delete pH;                                                    // --------<-------+---+
 #ifdef debug
@@ -478,13 +491,13 @@
     //G4int tNH=0;                    // Prototype of the number of secondaries inOut|
     try                                                           //                 |
-	   {                                                             //                 |
-				  delete output;                                            //                   |
+    {                                                             //                 |
+      delete output;                                              //                 |
       output = pan->Fragment();// DESTROYED in the end of the LOOP work space        |
       // @@@@@@@@@@@@@@ Temporary for the testing purposes --- Begin                 |
       //tNH=pan->GetNOfHadrons();     // For the test purposes of the String         |
       //if(tNH==2)                    // At least 2 hadrons are in the Constr.Output |
-				  //{//                                                                          |
+      //{//                                                                          |
       //  elF=true;                   // Just put a flag for the ellastic Scattering |
-	     //  delete output;              // Delete a prototype of dummy G4QHadronVector |
+      //  delete output;              // Delete a prototype of dummy G4QHadronVector |
       //  output = pan->GetHadrons(); // DESTROYED in the end of the LOOP work space |
       //}//                                                                          |
@@ -496,11 +509,11 @@
     }                                                             //                 |
     catch (G4QException& error)//                                                    |
-	   {                                                             //                 |
-	     //#ifdef pdebug
+    {                                                             //                 |
+      //#ifdef pdebug
       G4cerr<<"**G4QAtomElectScat::PostStepDoIt: GEN Exception is catched"<<G4endl;//|
-	     //#endif
+      //#endif
       G4Exception("G4QAtomElSct::AtRestDoIt:","27",FatalException,"QString Excep");//|
     }                                                             //                 |
-    delete pan;                              // Delete the Nuclear Environment ---<--+
+    delete pan;                              // Delete the Nuclear Environment ---<--*
   }
   aParticleChange.Initialize(track);
@@ -534,5 +547,5 @@
     {
 #ifdef debug
-	     G4cout<<"G4QAtomElScat::PostStepDoIt: Intermediate particle is found i="<<i<<G4endl;
+      G4cout<<"G4QAtomElScat::PostStepDoIt: Intermediate particle is found i="<<i<<G4endl;
 #endif
       delete hadr;
@@ -547,5 +560,5 @@
     {
       if(G4UniformRand()>.5) theDefinition = G4KaonZeroLong::KaonZeroLong();   // K_L
-						else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
+      else                   theDefinition = G4KaonZeroShort::KaonZeroShort(); // K_S
     }
     else if(PDGCode==91000999) theDefinition = G4SigmaPlus::SigmaPlus();
@@ -554,10 +567,10 @@
     else if(PDGCode==91999999) theDefinition = G4XiZero::XiZero();
     else if(PDGCode==92998999) theDefinition = G4OmegaMinus::OmegaMinus();
-	   else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
+    else if(PDGCode >80000000) // Defines hypernuclei as normal nuclei (N=N+S Correction!)
     {
       G4int aZ = hadr->GetCharge();
       G4int aA = hadr->GetBaryonNumber();
 #ifdef pdebug
-						G4cout<<"G4QAtomicElectronScattering::AtRestDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
+      G4cout<<"G4QAtomicElectronScattering::AtRestDoIt:Ion Z="<<aZ<<", A="<<aA<<G4endl;
 #endif
       theDefinition = G4ParticleTable::GetParticleTable()->FindIon(aZ,aA,0,aZ);
@@ -567,9 +580,9 @@
     {
 #ifdef pdebug
-						G4cout<<"G4QAtomElectScat::PostStepDoIt:Define particle with PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QAtomElectScat::PostStepDoIt:Define particle with PDG="<<PDGCode<<G4endl;
 #endif
       theDefinition = G4QPDGToG4Particle::Get()->GetParticleDefinition(PDGCode);
 #ifdef pdebug
-						G4cout<<"G4QAtomElScat::PostStepDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
+      G4cout<<"G4QAtomElScat::PostStepDoIt:AfterParticleDefinition PDG="<<PDGCode<<G4endl;
 #endif
     }
@@ -593,5 +606,5 @@
 #endif
     theSec->Set4Momentum(h4M); //                                                         ^
-    delete hadr; // <-----<-----------<-------------<---------------------<---------<-----+
+    delete hadr; // <-----<-----------<-------------<---------------------<---------<-----*
 #ifdef debug
     G4ThreeVector curD=theSec->GetMomentumDirection();              //                    ^
@@ -607,5 +620,5 @@
 #endif
   } //                                                                                    |
-  delete output; // instances of the G4QHadrons from the output are already deleted above +
+  delete output; // instances of the G4QHadrons from the output are already deleted above *
   aParticleChange.ProposeTrackStatus(fStopAndKill);        // Kill the absorbed particle
   //return &aParticleChange;                               // This is not enough (ClearILL)
